function [bias variance]=biasvariance(X,u)
Nk=size(X,1);
T=size(X,2);
p=size(X,3);
BkNT=zeros(p,1);

MT=T^(1/4);

clear temp
for i=1:Nk
    for ppp=1:p
temp(ppp,:)=sum(sum(k0_MT(abs(repmat([1:T],Nk,1)-repmat([1:Nk]',1,T)),MT).*(X(i,:,ppp)*u(i,:)')));
    end
BkNT=BkNT+temp;
end

BkNT=-1/(Nk^(1/2)*T^(3/2))*BkNT;

demeanX=X-repmat(mean(X,2),1,T);


for ppp=1:p
X_demean_vector(:,ppp)=reshape(demeanX(:,:,ppp)',Nk*T,1);
end

phik=1/(Nk*T)*(X_demean_vector'*X_demean_vector);

bias=1/sqrt(Nk*T)*pinv(phik)*BkNT;



psik=zeros(p);
for i=1:Nk
    for t=1:T
        for s=1:T
            psik=psik+reshape(X(i,t,:),p,1)*reshape(X(i,s,:),p,1)'*u(i,t)*u(i,s);
        end
    end
end    


psik=psik/(Nk*T);

variance=pinv(phik)*psik*pinv(phik);


