function [final_beta_hat NTresiduals]=c_lasso_est(X,Y,K,lambda1)
warning off
% X: N x T x p matrix
% Y: N x T matrix
% K: number of groups
% lambda1: tuning parameters


if K==1
    disp('The number of group is 1. Within estiamtors should be used!')
end


forcegroup=1;

    p=size(X,3);                            
    N=size(Y,1);                            
    T=size(Y,2);                            



individualdummy=kron(eye(N),repmat(ones(T,1),1,p));



demeanX=X-repmat(mean(X,2),1,T);
demeanY=Y-repmat(mean(Y,2),1,T);

for ppp=1:p
X_demean_vector(:,ppp)=reshape(demeanX(:,:,ppp)',N*T,1);
X_vector(:,ppp)=reshape(X(:,:,ppp)',N*T,1);
end

Y_demean_vector=reshape(demeanY',N*T,1);
Y_vector=reshape(Y',N*T,1);



cvx_begin
  cvx_quiet(true) 
       variables beta_hat(N,p);
       
       minimize(  1/(N*T)*(Y_demean_vector- (repmat(X_demean_vector,1,N).*individualdummy)*reshape(beta_hat',N*p,1))'...
           *(Y_demean_vector- repmat(X_demean_vector,1,N).*individualdummy*reshape(beta_hat',N*p,1))   ); 
       
    
 cvx_end
 

  
  
  
beta_hat_ini=beta_hat;
a_hat_ini=zeros(K,p);


iternumber=0;
betacriterion=inf;
acriterion=inf;


while (acriterion>0.01||betacriterion>0.01)&&iternumber<25

    
        for ite=1:K
            
            
        if K>1    
            if ite==1
            penforiteration=rrownorm(beta_hat_ini,a_hat_ini(2:end,:));
            penforiteration=prod(penforiteration,2);
            end
            
            if ite>1&&ite<K
            penforiteration1=rrownorm(beta_hat_ini,a_hat_ini(ite+1:end,:));
            penforiteration2=rrownorm(beta_hat_update,a_hat_update(1:ite-1,:));
            penforiteration=prod(penforiteration1,2).*prod(penforiteration2,2);
            end
            
            if ite==K
            penforiteration2=rrownorm(beta_hat_update,a_hat_update(1:ite-1,:));
            penforiteration=prod(penforiteration2,2);
            end
            
            
            
        else
            penforiteration=1;
        end
      
%tic            
cvx_begin
  cvx_quiet(true) 
       variables beta_hat(N,p) one_a_hat(1,p);
       minimize( 1/(N*T)*(Y_demean_vector- (repmat(X_demean_vector,1,N).*individualdummy)*reshape(beta_hat',N*p,1))'...
           *(Y_demean_vector- repmat(X_demean_vector,1,N).*individualdummy*reshape(beta_hat',N*p,1)) ...
           +lambda1/N*sum(norms((beta_hat-repmat(one_a_hat,N,1)),2,2).*penforiteration)     );       
cvx_end
%toc  
  
a_hat_update(ite,:)=one_a_hat;
beta_hat_update=beta_hat;
all_beta_hat(:,:,ite)=beta_hat_update; 


        end
        

iternumber=iternumber+1;

eeps=0.001;

betacriterion=sum((beta_hat_update-beta_hat_ini).^2)/(sum(beta_hat_ini.^2)+eeps);
acriterion=sum((a_hat_update-a_hat_ini).^2)/(sum(a_hat_ini.^2)+eeps);


beta_hat_ini=beta_hat_update;
a_hat_ini=a_hat_update;




end


eps=0.01;

for kk=1:K
    for kkk=1:K
        if kkk==1
group(:,kk)=norms(all_beta_hat(:,:,1)-repmat(a_hat_update(kk,:),N,1),2,2)<eps;
        else
group(:,kk)=group(:,kk)+(norms(all_beta_hat(:,:,kkk)-repmat(a_hat_update(kk,:),N,1),2,2)<eps);
        end
    end
    

end


overlap=find(sum(group,2)>1);

if isempty(overlap)==1
%    disp('no overlap')
else
%disp('WARNING!!!!!!')
for ooo=1:size(overlap,1)
tempoverlap=find(group(overlap(ooo,:),:)==1);
tempoverlap(end)=[];
group(overlap(ooo,:),tempoverlap)=0;
end
end



ungrouped=1-min(1,sum(group,2));


ungrouped_beta_hat=repmat(ungrouped,1,p).*beta_hat(:,:,end);



final_beta_hat_unforced=ungrouped_beta_hat;
for kkkk=1:K
 final_beta_hat_unforced=final_beta_hat_unforced+repmat(group(:,kkkk),1,p).*repmat(a_hat_update(kkkk,:),N,1);
end



if forcegroup==1     
for kkk=1:K
    ungroupednorm(:,kkk)=norms(ungrouped_beta_hat-repmat(a_hat_update(kkk,:),N,1),2,2);
end

[temp minposition]=min(ungroupednorm,[],2);
for jjj=1:N
    ungrouped_beta_hat(jjj,:)=a_hat_update(minposition(jjj,:),:);
end


ungrouped_beta_hat=repmat(ungrouped,1,p).*ungrouped_beta_hat;
final_beta_hat=ungrouped_beta_hat;
for kkkk=1:K
 final_beta_hat=final_beta_hat+repmat(group(:,kkkk),1,p).*repmat(a_hat_update(kkkk,:),N,1);
end
end


residuals=Y_demean_vector-(repmat(X_demean_vector,1,N).*individualdummy)*reshape(final_beta_hat',N*p,1);
residuals_unforced=Y_demean_vector-(repmat(X_demean_vector,1,N).*individualdummy)*reshape(final_beta_hat_unforced',N*p,1);


NTresiduals=reshape(residuals,T,N)';


 
 





