clear X Y beta

if DDGP==1||DDGP==2||DDGP==4||DDGP==5
beta=zeros(N,p);
beta(1:N*0.3,:)=repmat([0.5 -0.5],N*0.3,1);
beta(N*0.3+1:N*0.6,:)=repmat([-0.5 0.5],N*0.3,1);
end

if DDGP==3
beta(:,1)=0.5+randn(N,1);
beta(:,2)=-0.5+rand(N,1);
end


if DDGP==4
beta=beta+0.1*randn(N,p);
end


%static DGP
if DDGP==1
mu=randn(N,1);

for ppp=1:p
X(:,:,ppp)=randn(N,T)+repmat(mu,1,T);
end


u=randn(N,T);
Y=repmat(mu,1,T)+u;
for ppp=1:p
    Y=Y+repmat(beta(:,ppp),1,T).*X(:,:,ppp);
end

end





%dynamic DGP 
if DDGP==2||DDGP==3||DDGP==4||DDGP==5
    
clear X Y  

TTT=1000+T;
mu=randn(N,1);


if DDGP==5
    
time_effect=randn(1,TTT);

for ppp=1  
X(:,:,ppp)=randn(N,TTT)+repmat(mu,1,TTT)+repmat(time_effect,N,1);
end

else

for ppp=1
X(:,:,ppp)=randn(N,TTT)+repmat(mu,1,TTT);
end

end

sncontrol1=1;
sncontro12=1;

if DDGP==5
sncontrol1=0.5;
sncontro12=0.5;
end


u=randn(N,TTT);

Y(:,1)=zeros(N,1);
for ttt=2:TTT
    X(:,ttt,2)=Y(:,ttt-1);
    
    Y(:,ttt)=sncontrol1*mu+u(:,ttt);
    
    if DDGP==5
    Y(:,ttt)=Y(:,ttt)+sncontro12*repmat(time_effect(:,ttt),N,1);
    end
    
    
for ppp=1:p
    Y(:,ttt)=Y(:,ttt)+beta(:,ppp).*X(:,ttt,ppp);
end

end



Y=Y(:,end-T+1:end);
X=X(:,end-T+1:end,:);


end











