cvx_setup
clc
clear

DDGP=5;

Kmax=8;
cconsall=[0.25 0.5 0.75];
rrate=-1/3;


if DDGP==5
include_time_effect=1;
else
include_time_effect=0;
end



sstandardized=0;
ppostlasso=1;

    
  
        RR=1000;
        NTcomb=[40 10; 80 10; 40 40];
   

for connsindex=1:max(size(cconsall))
    
    
    ccons=cconsall(connsindex);
    
for ssamplesize=1:size(NTcomb,1)
    
    clear  J_original_post  saved_final_beta_hat informationcriterion IC_selected
    
    N=NTcomb(ssamplesize,1);
    T=NTcomb(ssamplesize,2); 


for r=1:RR
   
    %disp(['r=',num2str(r)])


%generating data%%%%%%%%%%%%%%%%%%%
randn('state',r)
rand('state',r)


p=2;                                        %
generatingdata                              %


OX=X;
OY=Y;


cccvalue=norminv(1-1/T,0,1);


lambda1=ccons*std(reshape(OY,N*T,1))^2*T^(rrate);%


for K=1:Kmax
   

X=OX;
Y=OY;
    
if K==1
    
if include_time_effect==1  
[final_beta_hat  NTresiduals]=within_est_time_effect(OX,OY);   
else
[final_beta_hat  NTresiduals]=within_est(OX,OY);   
end

end



if K>1
    
    
if include_time_effect==1    
[beta_hat NTresiduals_Lasso]=c_lasso_est_time_effect(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso_time_fixed_effects(OX,OY,beta_hat);
else 
[beta_hat NTresiduals_Lasso]=c_lasso_est(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso(OX,OY,beta_hat);
end




end 

sigma_hat_2=mean(mean(NTresiduals.^2));                    
rho=2/3*(N*T)^(-1/2);

informationcriterion(K,r)=log(sigma_hat_2)+rho*p*K;

saved_final_beta_hat(:,:,K,r)=final_beta_hat;

J_original_post(K,r)=test_stat(NTresiduals,OX);



end %end K

temp_selected=find(informationcriterion(:,r)==min(informationcriterion(:,r)));
IC_selected(:,r)=temp_selected(1);




end %end r





    disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
    disp(['DGP=',num2str(DDGP),'_N=',num2str(N),'_T=',num2str(T),'_cons=',num2str(ccons),'_rate=',num2str(rrate),'_R=',num2str(RR)])
    
    disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
    disp('Post_Lasso')
    disp([mean(J_original_post(1:3,:)>1.28,2) mean(J_original_post(1:3,:)>1.65,2) mean(J_original_post(1:3,:)>2.32,2)])
    disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
   
 
      
    estgroupnumber=ones(1,RR)*(Kmax+1);
    for rrrr=1:RR
    temp=find(J_original_post(:,rrrr)<=cccvalue,1);
    if isempty(temp)~=1
    estgroupnumber(:,rrrr)=temp(1);
    end
    end
    clear percentgroupnumber
    for kp=1:(Kmax+1)
    percentgroupnumber(:,kp)=mean(estgroupnumber==kp);
    end
    disp('Testing: Percentage of groups')
    disp(percentgroupnumber)   
     
    for kp=1:Kmax
      IC_percentgroupnumber(:,kp)=mean(IC_selected==kp);
    end  
   
    disp('IC: Percentage of groups')
    disp(IC_percentgroupnumber)
    disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')





end %end sample size


end %end cons
toc


