function [final_beta_hat residuals]=post_lasso(X,Y,beta_hat)

% X: N x T x k matrix
% Y: N x T matrix
% K: number of groups

    p=size(X,3);                            
    N=size(Y,1);                            
    T=size(Y,2);                            
 
unique_beta_hat1=unique(beta_hat(:,1));
K=size(unique_beta_hat1,1);


membership=zeros(N,1);
membership2=zeros(N,K);
for kkk=1:K
    groupmember{kkk}=find(beta_hat(:,1)==unique_beta_hat1(kkk));
    membership(groupmember{kkk},:)=kkk;
    membership2(groupmember{kkk},kkk)=1;
end

final_beta_hat=zeros(N,p);
residuals=zeros(N,T);

for kkkkkk=1:K
   
    XXX=X(groupmember{kkkkkk},:,:);
    YYY=Y(groupmember{kkkkkk},:);
   
    [tempbeta  temp_NTresidual_post]=within_est(XXX,YYY);    
      
    
    final_beta_hat(groupmember{kkkkkk},:)=tempbeta;
    residuals(groupmember{kkkkkk},:)=temp_NTresidual_post; 
end


