function [final_beta_hat residuals]=post_lasso_time_fixed_effects(X,Y,beta_hat)

% X: N x T x k matrix
% Y: N x T matrix
% K: number of groups



    p=size(X,3);                            
    N=size(Y,1);                            
    T=size(Y,2);                            
 

demeanX=X-repmat(mean(X,2),1,T);
demeanY=Y-repmat(mean(Y,2),1,T);

for ppp=1:p
X_demean_vector(:,ppp)=reshape(demeanX(:,:,ppp)',N*T,1);
X_vector(:,ppp)=reshape(X(:,:,ppp)',N*T,1);
end

Y_demean_vector=reshape(demeanY',N*T,1);
Y_vector=reshape(Y',N*T,1);

Y_demean_vector=reshape(demeanY',N*T,1);
Y_vector=reshape(Y',N*T,1);

double_demeanY=Y-repmat(mean(Y,2),1,T)-repmat(mean(Y,1),N,1)+repmat(mean(mean(Y)),N,T);
Y_double_demean_vector=reshape(double_demeanY',N*T,1);
A1=ones(N*T,N)*1/N-kron((eye(N)),ones(T,1));
B1=repmat(A1,1,p);
Xmatrix=[];

for ppp=1:p 
Xmatrix=[Xmatrix reshape(demeanX(:,:,ppp)',T,N)];
end
Xmatrix=repmat(Xmatrix,N,1);
Datamatrix=B1.*Xmatrix;



unique_beta_hat1=unique(beta_hat(:,1));
K=size(unique_beta_hat1,1);


membership=zeros(N,1);
membership2=zeros(N,K);
for kkk=1:K
    groupmember{kkk}=find(beta_hat(:,1)==unique_beta_hat1(kkk));
    membership(groupmember{kkk},:)=kkk;
    membership2(groupmember{kkk},kkk)=1;
end

  
alpha_hat1=reshape((-Datamatrix*kron(eye(p),membership2))\Y_double_demean_vector,K,p);
final_beta_hat=membership2*alpha_hat1;

residuals1=Y_double_demean_vector+Datamatrix*reshape(final_beta_hat,N*p,1);

residuals=reshape(residuals1,T,N)';
