function [final_beta_hat  NTresiduals]=within_est(X,Y)
warning off
% X: N x p x k matrix
% Y: N x p matrix
% K: number of groups
% lambda1: tuning parameters

    p=size(X,3);                            
    N=size(Y,1);                            
    T=size(Y,2);                            

individualdummy=kron(eye(N),repmat(ones(T,1),1,p));

demeanX=X-repmat(mean(X,2),1,T);
demeanY=Y-repmat(mean(Y,2),1,T);

for ppp=1:p
X_demean_vector(:,ppp)=reshape(demeanX(:,:,ppp)',N*T,1);
end

Y_demean_vector=reshape(demeanY',N*T,1);

beta_hat_homo=[X_demean_vector]\Y_demean_vector;

final_beta_hat=repmat(beta_hat_homo',N,1);

residuals=Y_demean_vector-(repmat(X_demean_vector,1,N).*individualdummy)*reshape(final_beta_hat',N*p,1);


NTresiduals=reshape(residuals,T,N)';




 





